/* This file was automatically generated.  Do not edit! */
typedef struct net_t net_t;
void net_unref(net_t *n);
#define UITCONN_DEL 1
void net_shutdown(net_t *n,void(*cb)(net_t *));
typedef struct cc_t cc_t;
void cc_free(cc_t *cc);
void net_connected(net_t *n,int sock,const char *addr,gboolean v6);
void cc_incoming(cc_t *cc,guint16 port,int sock,const char *addr,gboolean v6);
void net_peekbytes(net_t *n,int bytes,void(*cb)(net_t *,char *,int));
const char *ip6__unpack(unsigned char ip[16]);
#define ip6_unpack(ip) ip6__unpack((ip).s6_addr)
const char *ip4__unpack(guint32 ip);
#define ip4_unpack(ip) ip4__unpack((ip).s_addr)
typedef struct hub_user_t hub_user_t;
void cc_adc_connect(cc_t *cc,hub_user_t *u,const char *laddr,unsigned short port,gboolean tls,char *token);
void net_connect(net_t *n,const char *host,unsigned short port,const char *laddr,void(*cb)(net_t *,const char *));
gboolean ip6_isvalid(const char *str);
void cc_nmdc_connect(cc_t *cc,const char *host,unsigned short port,const char *laddr,gboolean tls);
void net_settls(net_t *n,gboolean serv,gboolean negotiate,void(*cb)(net_t *,const char *,int));
#define UITCONN_ADD 0
net_t *net_new(void *handle,void(*err)(net_t *,int,const char *));
typedef struct hub_t hub_t;
cc_t *cc_create(hub_t *hub);
#define NETERR_TIMEOUT 3
gboolean net_is_asy(net_t *n);
void net_disconnect(net_t *n);
gboolean net_is_disconnecting(net_t *n);
char *str_casestr(const char *haystack,const char *needle);
char *adc_unescape(const char *str,gboolean nmdc);
char *nmdc_lock2key(char *lock);
extern const char *main_version;
#define DLE_NOFILE  2 // User does not have the file at all
void dl_queue_setuerr(guint64 uid,char *tth,char e,const char *emsg);
void base32_encode_dat(const char *from,char *to,int len);
#define MAXCIDLEN 64 /* 512 bits */
#define isbase32(s) (strspn(s, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ234567") == strlen(s))
#define iscid(s) (strlen(s) >= 26 && strlen(s) <= MAXCIDLEN*8/5+1 && isbase32(s))
char *adc_getparam(char **a,char *name,char ***left);
void adc_append(GString *c,const char *name,const char *arg);
GString *adc_generate(char type,int cmd,int source,int dest);
void net_writestr(net_t *n,const char *msg);
typedef struct adc_cmd_t adc_cmd_t;
gboolean adc_parse(const char *str,adc_cmd_t *c,int *feats,GError **err);
#define ADC_TOCMDV(a, b, c) ((a) + ((b)<<8) + ((c)<<16))
enum adc_cmd_type {
#define C(n, a, b, c) ADCC_##n = ADC_TOCMDV(a,b,c)
  // Base commands (copied from DC++ / AdcCommand.h)
  C(SUP, 'S','U','P'), // F,T,C    - PROTOCOL, NORMAL
  C(STA, 'S','T','A'), // F,T,C,U  - All
  C(INF, 'I','N','F'), // F,T,C    - IDENTIFY, NORMAL
  C(MSG, 'M','S','G'), // F,T      - NORMAL
  C(SCH, 'S','C','H'), // F,T,C    - NORMAL (can be in U, but is discouraged)
  C(RES, 'R','E','S'), // F,T,C,U  - NORMAL
  C(CTM, 'C','T','M'), // F,T      - NORMAL
  C(RCM, 'R','C','M'), // F,T      - NORMAL
  C(GPA, 'G','P','A'), // F        - VERIFY
  C(PAS, 'P','A','S'), // T        - VERIFY
  C(QUI, 'Q','U','I'), // F        - IDENTIFY, VERIFY, NORMAL
  C(GET, 'G','E','T'), // C        - NORMAL (extensions may use in it F/T as well)
  C(GFI, 'G','F','I'), // C        - NORMAL
  C(SND, 'S','N','D'), // C        - NORMAL (extensions may use it in F/T as well)
  C(SID, 'S','I','D')  // F        - PROTOCOL
#undef C
};
typedef enum adc_cmd_type adc_cmd_type;
struct adc_cmd_t {
  char type;        // B|C|D|E|F|H|I|U
  adc_cmd_type cmd; // ADCC_*, but can also be something else. Unhandled commands should be ignored anyway.
  int source;       // Only when type = B|D|E|F
  int dest;         // Only when type = D|E
  char **argv;
  int argc;
};
#define DB_USERFLAG_GRANT  1 // User has been granted a slot
int db_users_get(guint64 hub,const char *nick);
#define VAR_TLSP_FORCE   8
#define VAR_TLSP_DISABLE 1
struct in6_addr ip6_pack(const char *str);
struct in_addr ip4_pack(const char *str);
#define ip6_cmp(a, b) memcmp(&(a), &(b), sizeof(struct in6_addr))
#define ip6_isany(ip) (ip6_cmp(ip, in6addr_any) == 0)
#define ip4_isany(ip) ((ip).s_addr == INADDR_ANY)
#define UITCONN_MOD 2  // when the nick or hub changes
void uit_conn_listchange(GSequenceIter *iter,int change);
typedef struct fl_list_t fl_list_t;
char *fl_list_path(fl_list_t *fl);
char *fl_local_path(fl_list_t *fl);
GSList *fl_local_from_tth(const char *root);
extern char *fl_local_list_file;
#define UI_COLORS \
  C(list_default,   "default")\
  C(list_header,    "default,bold")\
  C(list_select,    "default,bold")\
  C(log_default,    "default")\
  C(log_highlight,  "yellow,bold")\
  C(log_join,       "cyan,bold")\
  C(log_nick,       "default")\
  C(log_ownnick,    "default,bold")\
  C(log_quit,       "cyan")\
  C(log_time,       "black,bold")\
  C(separator,      "default,reverse")\
  C(tab_active,     "default,bold")\
  C(tabprio_high,   "magenta,bold")\
  C(tabprio_low,    "black,bold")\
  C(tabprio_med,    "cyan,bold")\
  C(title,          "default,reverse")
#define DLFILE_CHUNKSIZE (128*1024)
char *db_vars_get(guint64 hub,const char *name);
#define VAR_NOTB_DISABLE 1
#define VAR_SUDPP_PREFER  4
#define VAR_TLSP_PREFER  4
#define VARS\
  V(active,           1,1, f_bool,         p_bool,          su_bool,       NULL,         s_active_conf,   "false")\
  V(active_ip,        1,1, f_id,           p_active_ip,     su_old,        NULL,         s_active_conf,   NULL)\
  V(active_port,      1,1, f_int,          p_active_port,   NULL,          NULL,         s_active_conf,   NULL)\
  V(active_udp_port,  1,1, f_int,          p_active_port,   NULL,          g_active_udp, s_active_conf,   NULL)\
  V(adc_blom,         1,1, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(autoconnect,      0,1, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(autorefresh,      1,0, f_autorefresh,  p_autorefresh,   NULL,          NULL,         NULL,            "3600")\
  V(backlog,          1,1, f_backlog,      p_backlog,       NULL,          NULL,         NULL,            "0")\
  V(chat_only,        1,1, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(cid,              0,0, NULL,           NULL,            NULL,          NULL,         NULL,            i_cid_pid())\
  UI_COLORS \
  V(connection,       1,1, f_id,           p_connection,    su_old,        NULL,         s_hubinfo,       NULL)\
  V(description,      1,1, f_id,           p_id,            su_old,        NULL,         s_hubinfo,       NULL)\
  V(disconnect_offline,1,1,f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(download_dir,     1,0, f_id,           p_id,            su_path,       NULL,         s_dl_inc_dir,    i_dl_inc_dir(TRUE))\
  V(download_exclude, 1,0, f_id,           p_regex,         su_old,        NULL,         NULL,            NULL)\
  V(download_rate,    1,0, f_speed,        p_speed,         NULL,          NULL,         NULL,            NULL)\
  V(download_segment, 1,0, f_download_segment,p_download_segment,NULL,     NULL,         NULL,            g_strdup_printf("%"G_GUINT64_FORMAT, (guint64)DLFILE_CHUNKSIZE))\
  V(download_shared,  1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "true")\
  V(download_slots,   1,0, f_int,          p_int,           NULL,          NULL,         s_download_slots,"3")\
  V(email,            1,1, f_id,           p_id,            su_old,        NULL,         s_hubinfo,       NULL)\
  V(encoding,         1,1, f_id,           p_encoding,      su_encoding,   NULL,         NULL,            "UTF-8")\
  V(filelist_maxage,  1,0, f_interval,     p_interval,      su_old,        NULL,         NULL,            "604800")\
  V(fl_done,          0,0, NULL,           NULL,            NULL,          NULL,         NULL,            "false")\
  V(flush_file_cache, 1,0, f_ffc,          p_ffc,           su_ffc,        g_ffc,        s_ffc,           i_ffc())\
  V(geoip_cc,         1,0, f_id,           p_id,            su_path,       NULL,         s_geoip_cc,      NULL)\
  V(hash_rate,        1,0, f_speed,        p_speed,         NULL,          NULL,         NULL,            NULL)\
  V(hubaddr,          0,0, NULL,           NULL,            NULL,          NULL,         NULL,            NULL)\
  V(hubkp,            0,0, NULL,           NULL,            NULL,          NULL,         NULL,            NULL)\
  V(hubname,          0,1, f_id,           p_hubname,       su_old,        NULL,         s_hubname,       NULL)\
  V(incoming_dir,     1,0, f_id,           p_id,            su_path,       NULL,         s_dl_inc_dir,    i_dl_inc_dir(FALSE))\
  V(local_address,    1,1, f_id,           p_ip,            su_old,        NULL,         s_active_conf,   db_vars_get(0, "active_bind"))\
  V(log_debug,        1,0, f_bool,         p_bool,          su_bool,       NULL,         s_log_debug,     i_log_debug())\
  V(log_downloads,    1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "true")\
  V(log_hubchat,      1,1, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "true")\
  V(log_uploads,      1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "true")\
  V(max_ul_per_user,  1,1, f_int,          p_int_ge1,       NULL,          NULL,         NULL,            "1")\
  V(minislots,        1,0, f_int,          p_int_ge1,       NULL,          NULL,         NULL,            "3")\
  V(minislot_size,    1,0, f_minislot_size,p_minislot_size, NULL,          NULL,         NULL,            "65536")\
  V(nick,             1,1, f_id,           p_nick,          su_old,        NULL,         s_nick,          i_nick())\
  V(notify_bell,      1,0, f_notify_bell,  p_notify_bell,   su_notify_bell,g_notify_bell,s_notify_bell,   G_STRINGIFY(VAR_NOTB_DISABLE))\
  V(password,         0,1, f_password,     p_id,            NULL,          NULL,         s_password,      NULL)\
  V(pid,              0,0, NULL,           NULL,            NULL,          NULL,         NULL,            i_cid_pid())\
  V(reconnect_timeout,1,1, f_interval,     p_interval,      su_old,        NULL,         NULL,            "30")\
  V(sendfile,         1,0, f_sendfile,     p_sendfile,      su_bool,       NULL,         NULL,            "true")\
  V(share_emptydirs,  1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(share_exclude,    1,0, f_id,           p_regex,         su_old,        NULL,         NULL,            NULL)\
  V(share_hidden,     1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(share_symlinks,   1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(show_free_slots,  1,1, f_bool,         p_bool,          su_bool,       NULL,         s_hubinfo,       "false")\
  V(show_joinquit,    1,1, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(slots,            1,0, f_int,          p_int_ge1,       NULL,          NULL,         s_hubinfo,       "10")\
  V(sudp_policy,      1,0, f_sudp_policy,  p_sudp_policy,   su_sudp_policy,g_sudp_policy,s_sudp_policy,   G_STRINGIFY(VAR_SUDPP_PREFER))\
  V(tls_policy,       1,1, f_tls_policy,   p_tls_policy,    su_tls_policy, g_tls_policy, s_tls_policy,    G_STRINGIFY(VAR_TLSP_PREFER))\
  V(tls_priority,     1,0, f_id,           p_tls_priority,  su_old,        NULL,         NULL,            "NORMAL:-ARCFOUR-128")\
  V(ui_time_format,   1,0, f_id,           p_id,            su_old,        NULL,         NULL,            "[%H:%M:%S]")\
  V(upload_rate,      1,0, f_speed,        p_speed,         NULL,          NULL,         NULL,            NULL)
enum var_type {
#define V(n, gl, h, f, p, su, g, s, d) VAR_##n,
#define C(n, d) VAR_color_##n,
  VARS
#undef V
#undef C
  VAR_END
};
typedef enum var_type var_type;
char *var_get(guint64 h,var_type n);
int fl_save(fl_list_t *fl,const char *cid,int targetsize,gboolean zlib,GString *buf,const char *file,GError **err);
fl_list_t *fl_list_from_path(fl_list_t *root,const char *path);
extern fl_list_t *fl_local_list;
struct fl_list_t {
  fl_list_t *parent; // root = NULL
  GPtrArray *sub;
  guint64 size;   // including sub-items
  char tth[24];
  gboolean isfile : 1;
  gboolean hastth : 1;  // only if isfile==TRUE
  gboolean islocal : 1; // only if isfile==TRUE
  char name[1];
};
void net_write(net_t *n,const char *buf,int len);
const char *net_remoteaddr(net_t *n);
char *db_fl_gettthl(const char *root,int *len);
void base32_decode(const char *from,char *to);
#define istth(s) (strlen(s) == 39 && isbase32(s))
void net_sendfile(net_t *n,int fd,guint64 len,gboolean flush,void(*cb)(net_t *));
void net_readbytes(net_t *n,int bytes,void(*cb)(net_t *,char *,int));
gboolean dlfile_recv(void *vt,const char *buf,int len);
void net_recvfile(net_t *n,guint64 len,gboolean(*data)(void *,const char *,int),void(*done)(net_t *,void *),void *ctx);
extern GHashTable *dl_queue;
void dl_settthl(guint64 uid,char *tth,char *tthl,int len);
typedef struct dlfile_thread_t dlfile_thread_t;
void dlfile_recv_done(dlfile_thread_t *t);
void net_readmsg(net_t *n,unsigned char eom,void(*cb)(net_t *,char *,int));
void *net_handle(net_t *n);
gboolean net_is_connected(net_t *n);
typedef struct ratecalc_t ratecalc_t;
ratecalc_t *net_rate_in(net_t *n);
int ratecalc_rate(ratecalc_t *rc);
typedef struct dl_t dl_t;
dlfile_thread_t *dlfile_getchunk(dl_t *dl,guint64 uid,guint64 speed);
void net_writef(net_t *n,const char *fmt,...);
typedef struct ui_tab_t ui_tab_t;
struct dl_t {
  gboolean islist : 1;
  gboolean hastthl : 1;
  gboolean flopen : 1;   // For lists: Whether to open a browse tab after completed download
  gboolean flmatch : 1;  // For lists: Whether to match queue after completed download
  gboolean hassize : 1;  // For lists: Whether the size of the file list is known and validated
  gboolean allbusy : 1;  // When no more unallocated blocks are available (maintained by dlfile.c)
  signed char prio;      // DLP_*
  char error;            // DLE_*
  unsigned char active_threads; // number of active downloading threads (maintained by dlfile.c)
  int incfd;             // file descriptor for this file in <incoming_dir> (maintained by dlfile.c)
  char *error_msg;       // if error != DLE_NONE
  char *flsel;           // path to file/dir to select for filelists
  ui_tab_t *flpar;       // parent of the file list browser tab for filelists (might be a dangling pointer!)
  char hash[24];         // TTH for files, tiger(uid) for filelists
  GPtrArray *u;          // list of users who have this file (GSequenceIter pointers into dl_user.queue)
  guint64 size;          // total size of the file
  guint64 have;          // what we have so far
  guint64 hash_block;    // number of bytes that each block represents
  char *inc;             // path to the incomplete file (<incoming_dir>/<base32-hash>)
  char *dest;            // destination path
  GSequenceIter *iter;   // used by ui_dl
  GSList *threads;       // maintained by dlfile.c
  guint8 *bitmap;        // Only used if hastthl, maintained by dlfile.c
  guint bitmap_src;      // timeout source for flushing the bitmap, maintained by dlfile.c
  /* Maintained by dlfile.c, protects dl_t.{have,bitmap,bitmap_src} and
   * dlfile_thread_t.{allocated,avail,chunk}.
   * Some other fields are shared, too, but those are never modified while a
   * downloading thread is active and thus do not need synchronisation.  These
   * include dl_t.{size,islist,hash,hash_block,incfd} and possibly more.
   * TODO: dl.have isn't always protected yet! */
  GMutex lock;
};
void cc_download(cc_t *cc,dl_t *dl);
int var_get_int(guint64 h,var_type n);
typedef struct logfile_t logfile_t;
void logfile_add(logfile_t *l,const char *msg);
char *adc_escape(const char *str,gboolean nmdc);
guint64 net_left(net_t *n);
void base32_encode(const char *from,char *to);
logfile_t *logfile_create(const char *name);
struct logfile_t {
  int file;
  char *path;
  struct stat st;
};
int cc_slots_in_use(int *mini);
void cc_remove_hub(hub_t *hub);
gboolean var_get_bool(guint64 h,var_type n);
extern GHashTable *hub_uids;
void cc_global_onlinecheck();
void cc_disconnect(cc_t *cc,gboolean force);
void cc_global_close();
void cc_global_init();
extern GSequence *cc_list;
typedef struct tth_ctx_t tth_ctx_t;
typedef struct tiger_ctx_t tiger_ctx_t;
#define tiger_block_size 64
struct tiger_ctx_t {
  guint64 hash[3]; /* algorithm 192-bit state */
  char message[tiger_block_size]; /* 512-bit buffer for leftovers */
  guint64 length;  /* processed message length */
};
struct tth_ctx_t {
  tiger_ctx_t tiger;
  int leafnum; // There can be 2^29 leafs. Fits in an integer.
  int gotfirst;
  // Stack used to calculate the hash.
  //  Max. size = 2^29 * 1024 = 512 GiB
  // When the stack starts with a leaf node, the position in the stack
  // determines the data size the hash represents:
  //   size = tth_base_block << pos
  // (pos being the index from 0)
  char stack[29][24];
};
struct dlfile_thread_t {
  dl_t *dl;
  tth_ctx_t hash_tth;
  guint32 allocated; /* Number of remaining chunks allocated to this thread (including current) */
  guint32 avail;     /* Number of undownloaded chunks in and after this thread (including current & allocated) */
  guint32 chunk;     /* Current chunk number */
  guint32 len;       /* Number of bytes downloaded into this chunk */
  gboolean busy;     /* Whether this thread is being used */
  /* Fields for deferred error reporting */
  guint64 uid;
  char *err_msg, *uerr_msg;
  char err, uerr;
};
#define CCS_DISCONN    4 // waiting to get removed on a timeout
#define CCS_TRANSFER   3 // check cc->dl whether it's up or down
#define CCS_IDLE       2
#define CCS_HANDSHAKE  1
#define CCS_CONN       0
#define INTERFACE 0
guint64 hub_user_adc_id(guint64 hubid,const char *cid);
struct hub_user_t {
  gboolean hasinfo : 1;
  gboolean isop : 1;
  gboolean isjoined : 1; // managed by uit_hub_userchange()
  gboolean active : 1;
  gboolean hasudp4 : 1;
  gboolean hasudp6 : 1;
  gboolean hastls : 1;   // NMDC: 0x10 flag in $MyINFO; ADC: SU has ADCS or ADC0
  gboolean hasadc0 : 1;  // (ADC) Whether the SU flag was ADC0 (otherwise it was ADCS)
  unsigned char h_norm;
  unsigned char h_reg;
  unsigned char h_op;
  unsigned char slots;
  unsigned short udp4;
  unsigned short udp6;
  unsigned int as;       // auto-open slot if upload is below n bytes/s
  int sid;        // for ADC
  struct in_addr ip4;
  struct in6_addr ip6;
  hub_t *hub;
  char *name;     // UTF-8
  char *name_hub; // hub-encoded (NMDC)
  char *desc;
  char *conn;     // NMDC: string pointer, ADC: GUINT_TO_POINTER() of the US param
  char *mail;
  char *client;
  guint64 uid;
  guint64 sharesize;
  char *kp;      // ADC with KEYP, 32 bytes slice-alloc'ed
  GSequenceIter *iter; // used by ui_userlist_*
};
void cc_expect_add(hub_t *hub,hub_user_t *u,guint16 port,char *t,gboolean dl);
void dl_user_cc(guint64 uid,cc_t *cc);
struct cc_t {
  net_t *net;
  hub_t *hub;
  char *nick_raw; // (NMDC)
  char *nick;
  char *hub_name; // Copy of hub->tab->name when hub is reset to NULL
  gboolean adc : 1;
  gboolean tls : 1;
  gboolean active : 1;
  gboolean isop : 1;
  gboolean slot_mini : 1;
  gboolean slot_granted : 1;
  gboolean dl : 1;
  gboolean zlig : 1; // Only used for partial file lists, and only used on ADC because I don't know how NMDC clients handle that
  guint16 port;
  guint16 state;
  int dir;        // (NMDC) our direction. -1 = Upload, otherwise: Download $dir
  char *cid;      // (ADC) base32-encoded CID
  int timeout_src;
  char remoteaddr[64]; // xxx.xxx.xxx.xxx:ppppp or [ipv6addr]:ppppp
  char *token;    // (ADC)
  char *last_file;
  dlfile_thread_t *dlthread;
  guint64 uid;
  guint64 last_size;
  guint64 last_offset;
  guint64 last_length;
  gboolean last_tthl;
  time_t last_start;
  char last_hash[24];
  char *kp_real;  // (ADC) slice-alloc'ed with 32 bytes. This is the actually calculated keyprint.
  char *kp_user;  // (ADC) This is the keyprint from the users' INF
  GError *err;
  GSequenceIter *iter;
};
struct hub_t {
  gboolean adc : 16;       // TRUE = ADC, FALSE = NMDC protocol.
  gboolean tls : 16;
  int state;               // (ADC) ADC_S_*
  ui_tab_t *tab;
  net_t *net;

  // Hub info / config
  guint64 id;              // "hubid" number
  char *hubname;           // UTF-8, or NULL when unknown
  char *hubname_hub;       // (NMDC) in hub encoding

  // Our user info
  char *nick_hub;          // (NMDC) in hub encoding
  char *nick;              // UTF-8
  int sid;                 // (ADC) session ID
  char *ip;                // Our IP, as received from the hub
  gboolean nick_valid : 1; // TRUE is the above nick has also been validated (and we're properly logged in)
  gboolean isreg : 1;      // whether we used a password to login
  gboolean isop : 1;       // whether we're an OP or not

  // User list information
  int sharecount;
  guint64 sharesize;
  GHashTable *users;       // key = username (in hub encoding for NMDC)
  GHashTable *sessions;    // (ADC) key = sid

  // (NMDC) what we and the hub support
  gboolean supports_nogetinfo;

  // Timers
  guint nfo_timer;         // hub_send_nfo() timer
  guint reconnect_timer;   // reconnect timer

  // ADC login info
  char *gpa_salt;
  int gpa_salt_len;

  // TLS certificate verification
  char *kp;                // NULL if it matches config, 32 bytes slice-alloced otherwise

  // last info we sent to the hub
  char *nfo_desc, *nfo_conn, *nfo_mail, *nfo_ip;
  unsigned char nfo_slots, nfo_free_slots, nfo_h_norm, nfo_h_reg, nfo_h_op;
  guint64 nfo_share;
  guint16 nfo_udp_port;
  gboolean nfo_sup_tls, nfo_sup_sudp;

  // userlist fetching detection
  gboolean received_first;  // true if one precondition for joincomplete is satisfied.
  gboolean joincomplete;    // if we have the userlist
  guint joincomplete_timer; // fallback timer which ensures joincomplete is set at some point
};
typedef struct ui_tab_type_t ui_tab_type_t;
typedef struct ui_logwindow_t ui_logwindow_t;
struct ui_tab_t {
  // Tab type, can be any of the uit_* pointers defined in each uit_*.c file.
  ui_tab_type_t *type;

  // Tab priority, UIP_*.
  int prio;

  // Tab name, managed by the uit_* code.
  char *name;

  // The tab that opened this tab, may be NULL or dangling.
  ui_tab_t *parent;

  // If the tab has a logwindow, then this is a pointer to it. Used by the
  // ui_m() family to send messages to the tab.
  ui_logwindow_t *log;

  // If the tab is associated with a hub, then this is a pointer to it.
  // Currently used for uit_hub, uit_userlist and uit_msg.
  // TODO: Find a better abstraction and remove this pointer.
  hub_t *hub;
};
#define LOGWIN_BUF 1023 // must be 2^x-1
struct ui_logwindow_t {
  int lastlog;
  int lastvis;
  logfile_t *logfile;
  char *buf[LOGWIN_BUF+1];
  gboolean updated;
  int (*checkchat)(void *, char *, char *);
  void *handle;
};
struct ratecalc_t {
  GMutex lock; // protects total, last, rate and burst
  gint64 total;
  gint64 last;
  int burst;
  int rate;
  int reg; // 0 = not registered, >1 = registered with class #n
};
struct ui_tab_type_t {
  void (*draw)(ui_tab_t *);
  char *(*title)(ui_tab_t *);
  void (*key)(ui_tab_t *, guint64);
  void (*close)(ui_tab_t *);
};
