/* This file was automatically generated.  Do not edit! */
void cmd_suggest(char *ostr,char **sug);
void cmd_handle(char *ostr);
void fl_local_suggest(char *path,char **sug);
void db_users_rmhub(guint64 hub);
void db_vars_rmhub(guint64 hub);
#define LBT_TCP 2
#define LBT_IP4 4
#define LBT_TCP4 (LBT_TCP|LBT_IP4)
#define LBT_IP6 8
#define LBT_TCP6 (LBT_TCP|LBT_IP6)
#define LBT_UDP 1
#define LBT_UDP4 (LBT_UDP|LBT_IP4)
#define LBT_STR(x) ((x) == LBT_TCP4 ? "TCP4" : (x) == LBT_TCP6 ? "TCP6" : (x) == LBT_UDP4 ? "UDP4" : "UDP6")
typedef struct listen_bind_t listen_bind_t;
const char *listen_bind_ipport(listen_bind_t *b);
typedef struct listen_hub_bind_t listen_hub_bind_t;
struct listen_hub_bind_t {
  guint64 hubid;
  // A hub is always active in either IPv4 or IPv6, both is currently not supported.
  listen_bind_t *tcp, *udp;
};
extern GHashTable *hubs;
struct listen_bind_t {
  guint16 type; // LBT_*
  guint16 port;
  struct in_addr ip4;
  struct in6_addr ip6;
  int src; // glib event source
  int sock;
  GSList *hubs; // hubs that use this bind
};
extern GList *listen_binds;
typedef struct search_q_t search_q_t;
void search_q_free(search_q_t *q);
typedef struct ui_tab_t ui_tab_t;
typedef struct hub_t hub_t;
ui_tab_t *uit_search_create(hub_t *hub,search_q_t *q,GError **err);
void base32_decode(const char *from,char *to);
#define isbase32(s) (strspn(s, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ234567") == strlen(s))
#define istth(s) (strlen(s) == 39 && isbase32(s))
guint64 str_parsesize(const char *str);
typedef struct search_r_t search_r_t;
typedef void(*search_cb)(search_r_t *r,void *dat);
struct search_q_t {
  char type;    // NMDC search type (if 9, ignore all fields except tth)
  gboolean ge;  // TRUE -> match >= size; FALSE -> match <= size
  guint64 size; // 0 = disabled.
  char **query; // list of patterns to include
  char tth[24]; // only used when type = 9
  char key[16]; // SUDP key that we sent along with the SCH

  search_cb cb;
  void *cb_dat;
};
void uit_fl_queue(guint64 uid,gboolean force,const char *sel,ui_tab_t *parent,gboolean open,gboolean match);
int vars_byname(const char *n);
typedef struct hub_user_t hub_user_t;
void hub_kick(hub_t *hub,hub_user_t *u);
void hub_password(hub_t *hub,char *pass);
typedef struct net_t net_t;
gboolean net_is_connected(net_t *n);
void db_users_rm(guint64 hub,const char *nick);
int db_users_get(guint64 hub,const char *nick);
void db_users_set(guint64 hub,guint64 uid,const char *nick,int flags);
char *db_vars_get(guint64 hub,const char *name);
hub_t *hub_global_byid(guint64 id);
#define DB_USERFLAG_GRANT  1 // User has been granted a slot
typedef struct db_user_t db_user_t;
db_user_t **db_users_list();
struct db_user_t {
  guint64 hub;
  guint64 uid; // Set, but not actually used. Matching is on the nick.
  int flags;
  char nick[1];
};
void db_vacuum();
void dl_inc_clean();
gboolean dl_fl_clean(gpointer dat);
void db_fl_purgedata();
gboolean fl_gc();
void ui_draw();
#define UIM_NOTIFY  4
#define UIM_NOLOG  (64 | UIM_NOTIFY)
typedef struct dl_t dl_t;
void uit_dl_open(dl_t *dl,guint64 uid,ui_tab_t *parent);
typedef struct cc_t cc_t;
void uit_conn_open(cc_t *cc,ui_tab_t *parent);
char *ncdc_version();
void hub_user_suggest(hub_t *hub,char *str,char **sug);
typedef struct fl_list_t fl_list_t;
void fl_refresh(fl_list_t *dir);
fl_list_t *fl_local_from_path(const char *path);
void fl_unshare(const char *dir);
void db_share_rm(const char *name);
gboolean fl_is_refreshing(void);
void path_suggest(const char *opath,char **sug);
void fl_share(const char *dir);
void db_share_add(const char *name,const char *path);
char *path_expand(const char *path);
const char *db_share_path(const char *name);
void str_arg2_split(char *str,char **first,char **second);
char *str_formatsize(guint64 size);
fl_list_t *fl_list_file(const fl_list_t *dir,const char *name);
extern fl_list_t *fl_local_list;
struct fl_list_t {
  fl_list_t *parent; // root = NULL
  GPtrArray *sub;
  guint64 size;   // including sub-items
  char tth[24];
  gboolean isfile : 1;
  gboolean hastth : 1;  // only if isfile==TRUE
  gboolean islocal : 1; // only if isfile==TRUE
  char name[1];
};
typedef struct db_share_item_t db_share_item_t;
db_share_item_t *db_share_list();
struct db_share_item_t { char *name; char *path; };
gboolean uit_userlist_open(hub_t *hub,guint64 uid,const char *user,gboolean utf8);
typedef struct ui_logwindow_t ui_logwindow_t;
void ui_logwindow_clear(ui_logwindow_t *lw);
void listen_refresh();
void ui_tab_open(ui_tab_t *tab,gboolean sel,ui_tab_t *parent);
ui_tab_t *uit_hub_create(const char *name,gboolean conn);
gboolean str_is_valid_hubname(const char *name);
guint64 db_vars_hubid(const char *name);
char **db_vars_hubs();
void base32_encode_dat(const char *from,char *to,int len);
extern ui_tab_t *uit_main_tab;
extern GList *ui_tabs;
struct hub_t {
  gboolean adc : 16;       // TRUE = ADC, FALSE = NMDC protocol.
  gboolean tls : 16;
  int state;               // (ADC) ADC_S_*
  ui_tab_t *tab;
  net_t *net;

  // Hub info / config
  guint64 id;              // "hubid" number
  char *hubname;           // UTF-8, or NULL when unknown
  char *hubname_hub;       // (NMDC) in hub encoding

  // Our user info
  char *nick_hub;          // (NMDC) in hub encoding
  char *nick;              // UTF-8
  int sid;                 // (ADC) session ID
  char *ip;                // Our IP, as received from the hub
  gboolean nick_valid : 1; // TRUE is the above nick has also been validated (and we're properly logged in)
  gboolean isreg : 1;      // whether we used a password to login
  gboolean isop : 1;       // whether we're an OP or not

  // User list information
  int sharecount;
  guint64 sharesize;
  GHashTable *users;       // key = username (in hub encoding for NMDC)
  GHashTable *sessions;    // (ADC) key = sid

  // (NMDC) what we and the hub support
  gboolean supports_nogetinfo;

  // Timers
  guint nfo_timer;         // hub_send_nfo() timer
  guint reconnect_timer;   // reconnect timer

  // ADC login info
  char *gpa_salt;
  int gpa_salt_len;

  // TLS certificate verification
  char *kp;                // NULL if it matches config, 32 bytes slice-alloced otherwise

  // last info we sent to the hub
  char *nfo_desc, *nfo_conn, *nfo_mail, *nfo_ip;
  unsigned char nfo_slots, nfo_free_slots, nfo_h_norm, nfo_h_reg, nfo_h_op;
  guint64 nfo_share;
  guint16 nfo_udp_port;
  gboolean nfo_sup_tls, nfo_sup_sudp;

  // userlist fetching detection
  gboolean received_first;  // true if one precondition for joincomplete is satisfied.
  gboolean joincomplete;    // if we have the userlist
  guint joincomplete_timer; // fallback timer which ensures joincomplete is set at some point
};
typedef struct ui_tab_type_t ui_tab_type_t;
struct ui_tab_type_t {
  void (*draw)(ui_tab_t *);
  char *(*title)(ui_tab_t *);
  void (*key)(ui_tab_t *, guint64);
  void (*close)(ui_tab_t *);
};
extern ui_tab_type_t uit_main[1];
extern ui_tab_type_t uit_main[1];
void hub_disconnect(hub_t *hub,gboolean recon);
void hub_connect(hub_t *hub);
gboolean net_is_idle(net_t *n);
#define UI_COLORS \
  C(list_default,   "default")\
  C(list_header,    "default,bold")\
  C(list_select,    "default,bold")\
  C(log_default,    "default")\
  C(log_highlight,  "yellow,bold")\
  C(log_join,       "cyan,bold")\
  C(log_nick,       "default")\
  C(log_ownnick,    "default,bold")\
  C(log_quit,       "cyan")\
  C(log_time,       "black,bold")\
  C(separator,      "default,reverse")\
  C(tab_active,     "default,bold")\
  C(tabprio_high,   "magenta,bold")\
  C(tabprio_low,    "black,bold")\
  C(tabprio_med,    "cyan,bold")\
  C(title,          "default,reverse")
#define DLFILE_CHUNKSIZE (128*1024)
#define VAR_NOTB_DISABLE 1
#define VAR_SUDPP_PREFER  4
#define VAR_TLSP_PREFER  4
#define VARS\
  V(active,           1,1, f_bool,         p_bool,          su_bool,       NULL,         s_active_conf,   "false")\
  V(active_ip,        1,1, f_id,           p_active_ip,     su_old,        NULL,         s_active_conf,   NULL)\
  V(active_port,      1,1, f_int,          p_active_port,   NULL,          NULL,         s_active_conf,   NULL)\
  V(active_udp_port,  1,1, f_int,          p_active_port,   NULL,          g_active_udp, s_active_conf,   NULL)\
  V(adc_blom,         1,1, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(autoconnect,      0,1, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(autorefresh,      1,0, f_autorefresh,  p_autorefresh,   NULL,          NULL,         NULL,            "3600")\
  V(backlog,          1,1, f_backlog,      p_backlog,       NULL,          NULL,         NULL,            "0")\
  V(chat_only,        1,1, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(cid,              0,0, NULL,           NULL,            NULL,          NULL,         NULL,            i_cid_pid())\
  UI_COLORS \
  V(connection,       1,1, f_id,           p_connection,    su_old,        NULL,         s_hubinfo,       NULL)\
  V(description,      1,1, f_id,           p_id,            su_old,        NULL,         s_hubinfo,       NULL)\
  V(disconnect_offline,1,1,f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(download_dir,     1,0, f_id,           p_id,            su_path,       NULL,         s_dl_inc_dir,    i_dl_inc_dir(TRUE))\
  V(download_exclude, 1,0, f_id,           p_regex,         su_old,        NULL,         NULL,            NULL)\
  V(download_rate,    1,0, f_speed,        p_speed,         NULL,          NULL,         NULL,            NULL)\
  V(download_segment, 1,0, f_download_segment,p_download_segment,NULL,     NULL,         NULL,            g_strdup_printf("%"G_GUINT64_FORMAT, (guint64)DLFILE_CHUNKSIZE))\
  V(download_shared,  1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "true")\
  V(download_slots,   1,0, f_int,          p_int,           NULL,          NULL,         s_download_slots,"3")\
  V(email,            1,1, f_id,           p_id,            su_old,        NULL,         s_hubinfo,       NULL)\
  V(encoding,         1,1, f_id,           p_encoding,      su_encoding,   NULL,         NULL,            "UTF-8")\
  V(filelist_maxage,  1,0, f_interval,     p_interval,      su_old,        NULL,         NULL,            "604800")\
  V(fl_done,          0,0, NULL,           NULL,            NULL,          NULL,         NULL,            "false")\
  V(flush_file_cache, 1,0, f_ffc,          p_ffc,           su_ffc,        g_ffc,        s_ffc,           i_ffc())\
  V(geoip_cc,         1,0, f_id,           p_id,            su_path,       NULL,         s_geoip_cc,      NULL)\
  V(hash_rate,        1,0, f_speed,        p_speed,         NULL,          NULL,         NULL,            NULL)\
  V(hubaddr,          0,0, NULL,           NULL,            NULL,          NULL,         NULL,            NULL)\
  V(hubkp,            0,0, NULL,           NULL,            NULL,          NULL,         NULL,            NULL)\
  V(hubname,          0,1, f_id,           p_hubname,       su_old,        NULL,         s_hubname,       NULL)\
  V(incoming_dir,     1,0, f_id,           p_id,            su_path,       NULL,         s_dl_inc_dir,    i_dl_inc_dir(FALSE))\
  V(local_address,    1,1, f_id,           p_ip,            su_old,        NULL,         s_active_conf,   db_vars_get(0, "active_bind"))\
  V(log_debug,        1,0, f_bool,         p_bool,          su_bool,       NULL,         s_log_debug,     i_log_debug())\
  V(log_downloads,    1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "true")\
  V(log_hubchat,      1,1, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "true")\
  V(log_uploads,      1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "true")\
  V(max_ul_per_user,  1,1, f_int,          p_int_ge1,       NULL,          NULL,         NULL,            "1")\
  V(minislots,        1,0, f_int,          p_int_ge1,       NULL,          NULL,         NULL,            "3")\
  V(minislot_size,    1,0, f_minislot_size,p_minislot_size, NULL,          NULL,         NULL,            "65536")\
  V(nick,             1,1, f_id,           p_nick,          su_old,        NULL,         s_nick,          i_nick())\
  V(notify_bell,      1,0, f_notify_bell,  p_notify_bell,   su_notify_bell,g_notify_bell,s_notify_bell,   G_STRINGIFY(VAR_NOTB_DISABLE))\
  V(password,         0,1, f_password,     p_id,            NULL,          NULL,         s_password,      NULL)\
  V(pid,              0,0, NULL,           NULL,            NULL,          NULL,         NULL,            i_cid_pid())\
  V(reconnect_timeout,1,1, f_interval,     p_interval,      su_old,        NULL,         NULL,            "30")\
  V(sendfile,         1,0, f_sendfile,     p_sendfile,      su_bool,       NULL,         NULL,            "true")\
  V(share_emptydirs,  1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(share_exclude,    1,0, f_id,           p_regex,         su_old,        NULL,         NULL,            NULL)\
  V(share_hidden,     1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(share_symlinks,   1,0, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(show_free_slots,  1,1, f_bool,         p_bool,          su_bool,       NULL,         s_hubinfo,       "false")\
  V(show_joinquit,    1,1, f_bool,         p_bool,          su_bool,       NULL,         NULL,            "false")\
  V(slots,            1,0, f_int,          p_int_ge1,       NULL,          NULL,         s_hubinfo,       "10")\
  V(sudp_policy,      1,0, f_sudp_policy,  p_sudp_policy,   su_sudp_policy,g_sudp_policy,s_sudp_policy,   G_STRINGIFY(VAR_SUDPP_PREFER))\
  V(tls_policy,       1,1, f_tls_policy,   p_tls_policy,    su_tls_policy, g_tls_policy, s_tls_policy,    G_STRINGIFY(VAR_TLSP_PREFER))\
  V(tls_priority,     1,0, f_id,           p_tls_priority,  su_old,        NULL,         NULL,            "NORMAL:-ARCFOUR-128")\
  V(ui_time_format,   1,0, f_id,           p_id,            su_old,        NULL,         NULL,            "[%H:%M:%S]")\
  V(upload_rate,      1,0, f_speed,        p_speed,         NULL,          NULL,         NULL,            NULL)
enum var_type {
#define V(n, gl, h, f, p, su, g, s, d) VAR_##n,
#define C(n, d) VAR_color_##n,
  VARS
#undef V
#undef C
  VAR_END
};
typedef enum var_type var_type;
gboolean var_set(guint64 h,var_type n,const char *v,GError **err);
char *var_get(guint64 h,var_type n);
void strv_prefix(char **arr,const char *str,...);
typedef struct var_t var_t;
struct var_t {
  // Name does not necessarily have to correspond to the name in the 'vars'
  // table. Though in that case special getraw() and setraw() functions have to
  // be used.
  const char *name;
  gboolean global : 1;
  gboolean hub : 1;

  // Formats the raw value for human viewing. Returned string will be
  // g_free()'d. May be NULL if !hub && !global.
  char *(*format)(const char *val);

  // Validates and parses a human input string and returns the "raw" string.
  // Returned string will be g_free()'d. May also return an error if the
  // setting can't be set yet (e.g. if some other setting has to be set
  // first.). Will write any warnings or notes to ui_m(NULL, ..).
  // May be NULL if !hub && !global.
  char *(*parse)(const char *val, GError **err);

  // Suggestion function. *old is the old (raw) value. *val the current string
  // on the input line. May be NULL if no suggestions are available.
  void (*sug)(const char *old, const char *val, char **sug);

  // Get the raw value. The returned string will not be freed and may be
  // modified later. When this is NULL, db_vars_get() is used.
  char *(*getraw)(guint64 hub, const char *name);

  // Set the raw value and make sure it's active. val = NULL to unset it. In
  // general, this function should not fail if parse() didn't return an error,
  // but it may still refuse to set the value set *err to indicate failure.
  // (e.g. when trying to unset a var that must always exist).
  gboolean (*setraw)(guint64 hub, const char *name, const char *val, GError **err);

  // Default raw value, to be used when getraw() returns NULL.
  char *def;
};
extern var_t vars[];
void ui_mf(ui_tab_t *tab,int flags,const char *fmt,...);
gboolean uit_msg_open(guint64 group,ui_tab_t *parent);
hub_user_t *hub_user_get(hub_t *hub,const char *name);
void hub_msg(hub_t *hub,hub_user_t *user,const char *str,gboolean me);
extern GHashTable *hub_uids;
struct hub_user_t {
  gboolean hasinfo : 1;
  gboolean isop : 1;
  gboolean isjoined : 1; // managed by uit_hub_userchange()
  gboolean active : 1;
  gboolean hasudp4 : 1;
  gboolean hasudp6 : 1;
  gboolean hastls : 1;   // NMDC: 0x10 flag in $MyINFO; ADC: SU has ADCS or ADC0
  gboolean hasadc0 : 1;  // (ADC) Whether the SU flag was ADC0 (otherwise it was ADCS)
  unsigned char h_norm;
  unsigned char h_reg;
  unsigned char h_op;
  unsigned char slots;
  unsigned short udp4;
  unsigned short udp6;
  unsigned int as;       // auto-open slot if upload is below n bytes/s
  int sid;        // for ADC
  struct in_addr ip4;
  struct in6_addr ip6;
  hub_t *hub;
  char *name;     // UTF-8
  char *name_hub; // hub-encoded (NMDC)
  char *desc;
  char *conn;     // NMDC: string pointer, ADC: GUINT_TO_POINTER() of the US param
  char *mail;
  char *client;
  guint64 uid;
  guint64 sharesize;
  char *kp;      // ADC with KEYP, 32 bytes slice-alloc'ed
  GSequenceIter *iter; // used by ui_userlist_*
};
guint64 uit_msg_uid(ui_tab_t *tab);
void hub_say(hub_t *hub,const char *str,gboolean me);
void ui_m(ui_tab_t *tab,int flags,const char *msg);
extern ui_tab_type_t uit_msg[1];
extern ui_tab_type_t uit_msg[1];
extern ui_tab_type_t uit_hub[1];
extern ui_tab_type_t uit_hub[1];
extern GList *ui_tab_cur;
struct ui_tab_t {
  // Tab type, can be any of the uit_* pointers defined in each uit_*.c file.
  ui_tab_type_t *type;

  // Tab priority, UIP_*.
  int prio;

  // Tab name, managed by the uit_* code.
  char *name;

  // The tab that opened this tab, may be NULL or dangling.
  ui_tab_t *parent;

  // If the tab has a logwindow, then this is a pointer to it. Used by the
  // ui_m() family to send messages to the tab.
  ui_logwindow_t *log;

  // If the tab is associated with a hub, then this is a pointer to it.
  // Currently used for uit_hub, uit_userlist and uit_msg.
  // TODO: Find a better abstraction and remove this pointer.
  hub_t *hub;
};
void ncdc_quit();
typedef struct dlfile_thread_t dlfile_thread_t;
struct cc_t {
  net_t *net;
  hub_t *hub;
  char *nick_raw; // (NMDC)
  char *nick;
  char *hub_name; // Copy of hub->tab->name when hub is reset to NULL
  gboolean adc : 1;
  gboolean tls : 1;
  gboolean active : 1;
  gboolean isop : 1;
  gboolean slot_mini : 1;
  gboolean slot_granted : 1;
  gboolean dl : 1;
  gboolean zlig : 1; // Only used for partial file lists, and only used on ADC because I don't know how NMDC clients handle that
  guint16 port;
  guint16 state;
  int dir;        // (NMDC) our direction. -1 = Upload, otherwise: Download $dir
  char *cid;      // (ADC) base32-encoded CID
  int timeout_src;
  char remoteaddr[64]; // xxx.xxx.xxx.xxx:ppppp or [ipv6addr]:ppppp
  char *token;    // (ADC)
  char *last_file;
  dlfile_thread_t *dlthread;
  guint64 uid;
  guint64 last_size;
  guint64 last_offset;
  guint64 last_length;
  gboolean last_tthl;
  time_t last_start;
  char last_hash[24];
  char *kp_real;  // (ADC) slice-alloc'ed with 32 bytes. This is the actually calculated keyprint.
  char *kp_user;  // (ADC) This is the keyprint from the users' INF
  GError *err;
  GSequenceIter *iter;
};
struct dl_t {
  gboolean islist : 1;
  gboolean hastthl : 1;
  gboolean flopen : 1;   // For lists: Whether to open a browse tab after completed download
  gboolean flmatch : 1;  // For lists: Whether to match queue after completed download
  gboolean hassize : 1;  // For lists: Whether the size of the file list is known and validated
  gboolean allbusy : 1;  // When no more unallocated blocks are available (maintained by dlfile.c)
  signed char prio;      // DLP_*
  char error;            // DLE_*
  unsigned char active_threads; // number of active downloading threads (maintained by dlfile.c)
  int incfd;             // file descriptor for this file in <incoming_dir> (maintained by dlfile.c)
  char *error_msg;       // if error != DLE_NONE
  char *flsel;           // path to file/dir to select for filelists
  ui_tab_t *flpar;       // parent of the file list browser tab for filelists (might be a dangling pointer!)
  char hash[24];         // TTH for files, tiger(uid) for filelists
  GPtrArray *u;          // list of users who have this file (GSequenceIter pointers into dl_user.queue)
  guint64 size;          // total size of the file
  guint64 have;          // what we have so far
  guint64 hash_block;    // number of bytes that each block represents
  char *inc;             // path to the incomplete file (<incoming_dir>/<base32-hash>)
  char *dest;            // destination path
  GSequenceIter *iter;   // used by ui_dl
  GSList *threads;       // maintained by dlfile.c
  guint8 *bitmap;        // Only used if hastthl, maintained by dlfile.c
  guint bitmap_src;      // timeout source for flushing the bitmap, maintained by dlfile.c
  /* Maintained by dlfile.c, protects dl_t.{have,bitmap,bitmap_src} and
   * dlfile_thread_t.{allocated,avail,chunk}.
   * Some other fields are shared, too, but those are never modified while a
   * downloading thread is active and thus do not need synchronisation.  These
   * include dl_t.{size,islist,hash,hash_block,incfd} and possibly more.
   * TODO: dl.have isn't always protected yet! */
  GMutex lock;
};
typedef struct tth_ctx_t tth_ctx_t;
typedef struct tiger_ctx_t tiger_ctx_t;
#define tiger_block_size 64
struct tiger_ctx_t {
  guint64 hash[3]; /* algorithm 192-bit state */
  char message[tiger_block_size]; /* 512-bit buffer for leftovers */
  guint64 length;  /* processed message length */
};
struct tth_ctx_t {
  tiger_ctx_t tiger;
  int leafnum; // There can be 2^29 leafs. Fits in an integer.
  int gotfirst;
  // Stack used to calculate the hash.
  //  Max. size = 2^29 * 1024 = 512 GiB
  // When the stack starts with a leaf node, the position in the stack
  // determines the data size the hash represents:
  //   size = tth_base_block << pos
  // (pos being the index from 0)
  char stack[29][24];
};
struct dlfile_thread_t {
  dl_t *dl;
  tth_ctx_t hash_tth;
  guint32 allocated; /* Number of remaining chunks allocated to this thread (including current) */
  guint32 avail;     /* Number of undownloaded chunks in and after this thread (including current & allocated) */
  guint32 chunk;     /* Current chunk number */
  guint32 len;       /* Number of bytes downloaded into this chunk */
  gboolean busy;     /* Whether this thread is being used */
  /* Fields for deferred error reporting */
  guint64 uid;
  char *err_msg, *uerr_msg;
  char err, uerr;
};
struct search_r_t {
  guint64 uid;
  char *file;     // full path + filename. Slashes as path saparator, no trailing slash
  guint64 size;   // file size, G_MAXUINT64 = directory
  int slots;      // free slots
  char tth[24];   // TTH root (for regular files)
};
typedef struct logfile_t logfile_t;
#define LOGWIN_BUF 1023 // must be 2^x-1
struct ui_logwindow_t {
  int lastlog;
  int lastvis;
  logfile_t *logfile;
  char *buf[LOGWIN_BUF+1];
  gboolean updated;
  int (*checkchat)(void *, char *, char *);
  void *handle;
};
struct logfile_t {
  int file;
  char *path;
  struct stat st;
};
