/* This file was automatically generated.  Do not edit! */
#define INPT_CODE(key)  ((gunichar)((key)&G_GUINT64_CONSTANT(0xFFFFFFFF)))
#define INPT_TYPE(key)  ((char)((key)>>32))
#define KEY_ESCAPE                (KEY_MAX+1)
#define KEY_BRACKETED_PASTE_START (KEY_ESCAPE+1)
#define KEY_BRACKETED_PASTE_END   (KEY_BRACKETED_PASTE_START+1)
#define UIM_NOTIFY  4
#define UIM_NOLOG  (64 | UIM_NOTIFY)
typedef struct ui_tab_t ui_tab_t;
void ui_mf(ui_tab_t *tab,int flags,const char *fmt,...);
#define INPT_ALT(code)  (((guint64)3<<32) + (guint64)(code))
#define INPT_CTRL(code) (((guint64)2<<32) + (guint64)(code))
#define INPT_KEY(code)  (((guint64)0<<32) + (guint64)(code))
typedef struct ui_textinput_t ui_textinput_t;
gboolean ui_textinput_key(ui_textinput_t *ti,guint64 key,char **str);
#define gunichar_width(x) (g_unichar_iswide(x) ? 2 : g_unichar_iszerowidth(x) ? 0 : 1)
typedef struct ui_cursor_t ui_cursor_t;
struct ui_cursor_t {
  int x;
  int y;
};
void ui_textinput_draw(ui_textinput_t *ti,int y,int x,int col,ui_cursor_t *cur);
char *ui_textinput_reset(ui_textinput_t *ti);
void ui_textinput_free(ui_textinput_t *ti);
extern gboolean ui_beep;
void ui_textinput_set(ui_textinput_t *ti,const char *str);
char *ui_textinput_get(ui_textinput_t *ti);
ui_textinput_t *ui_textinput_create(gboolean usehist,void(*complete)(char *,char **));
struct ui_textinput_t {
  int pos; // position of the cursor, in number of characters
  GString *str;
  gboolean usehist;
  int s_pos;
  char *s_q;
  gboolean s_top;
  void (*complete)(char *, char **);
  char *c_q, *c_last, **c_sug;
  int c_cur;
  gboolean bracketed_paste;
};
#define INTERFACE 0
void ui_cmdhist_close();
extern const char *db_dir;
void ui_cmdhist_init(const char *file);
typedef struct ui_tab_type_t ui_tab_type_t;
typedef struct ui_logwindow_t ui_logwindow_t;
typedef struct hub_t hub_t;
struct ui_tab_t {
  // Tab type, can be any of the uit_* pointers defined in each uit_*.c file.
  ui_tab_type_t *type;

  // Tab priority, UIP_*.
  int prio;

  // Tab name, managed by the uit_* code.
  char *name;

  // The tab that opened this tab, may be NULL or dangling.
  ui_tab_t *parent;

  // If the tab has a logwindow, then this is a pointer to it. Used by the
  // ui_m() family to send messages to the tab.
  ui_logwindow_t *log;

  // If the tab is associated with a hub, then this is a pointer to it.
  // Currently used for uit_hub, uit_userlist and uit_msg.
  // TODO: Find a better abstraction and remove this pointer.
  hub_t *hub;
};
typedef struct logfile_t logfile_t;
#define LOGWIN_BUF 1023 // must be 2^x-1
struct ui_logwindow_t {
  int lastlog;
  int lastvis;
  logfile_t *logfile;
  char *buf[LOGWIN_BUF+1];
  gboolean updated;
  int (*checkchat)(void *, char *, char *);
  void *handle;
};
struct logfile_t {
  int file;
  char *path;
  struct stat st;
};
typedef struct net_t net_t;
struct hub_t {
  gboolean adc : 16;       // TRUE = ADC, FALSE = NMDC protocol.
  gboolean tls : 16;
  int state;               // (ADC) ADC_S_*
  ui_tab_t *tab;
  net_t *net;

  // Hub info / config
  guint64 id;              // "hubid" number
  char *hubname;           // UTF-8, or NULL when unknown
  char *hubname_hub;       // (NMDC) in hub encoding

  // Our user info
  char *nick_hub;          // (NMDC) in hub encoding
  char *nick;              // UTF-8
  int sid;                 // (ADC) session ID
  char *ip;                // Our IP, as received from the hub
  gboolean nick_valid : 1; // TRUE is the above nick has also been validated (and we're properly logged in)
  gboolean isreg : 1;      // whether we used a password to login
  gboolean isop : 1;       // whether we're an OP or not

  // User list information
  int sharecount;
  guint64 sharesize;
  GHashTable *users;       // key = username (in hub encoding for NMDC)
  GHashTable *sessions;    // (ADC) key = sid

  // (NMDC) what we and the hub support
  gboolean supports_nogetinfo;

  // Timers
  guint nfo_timer;         // hub_send_nfo() timer
  guint reconnect_timer;   // reconnect timer

  // ADC login info
  char *gpa_salt;
  int gpa_salt_len;

  // TLS certificate verification
  char *kp;                // NULL if it matches config, 32 bytes slice-alloced otherwise

  // last info we sent to the hub
  char *nfo_desc, *nfo_conn, *nfo_mail, *nfo_ip;
  unsigned char nfo_slots, nfo_free_slots, nfo_h_norm, nfo_h_reg, nfo_h_op;
  guint64 nfo_share;
  guint16 nfo_udp_port;
  gboolean nfo_sup_tls, nfo_sup_sudp;

  // userlist fetching detection
  gboolean received_first;  // true if one precondition for joincomplete is satisfied.
  gboolean joincomplete;    // if we have the userlist
  guint joincomplete_timer; // fallback timer which ensures joincomplete is set at some point
};
struct ui_tab_type_t {
  void (*draw)(ui_tab_t *);
  char *(*title)(ui_tab_t *);
  void (*key)(ui_tab_t *, guint64);
  void (*close)(ui_tab_t *);
};
